#pragma once

#include <ArmarXCore/interface/core/PackagePath.ice>
#include <RobotAPI/interface/armem/memory.ice>

module armarx
{
    module armem
    {
        module data
        {
            struct LoadInput
            {
                armarx::data::PackagePath path;
                armem::data::MemoryID entityID;
            };

            struct LoadResult
            {
                bool success = false;
                long timeStartedMicroSeconds;
                long timeFinishedMicroSeconds;

                long numLoadedCoreSegments;
                long numLoadedProviderSegments;
                long numLoadedEntities;
                long numLoadedEntitySnapshots;

                string errorMessage;
            };

            struct StoreInput
            {
                armarx::data::PackagePath path;
                armem::data::MemoryID entityID;
            };

            struct StoreResult
            {
                bool success = false;
                long timeStartedMicroSeconds;
                long timeFinishedMicroSeconds;

                long numStoredCoreSegments;
                long numStoredLoadedProviderSegments;
                long numStoredLoadedEntities;
                long numStoredLoadedEntitySnapshots;

                string errorMessage;
            };
        };
    };
};
