#include "NlohmannJSONDiskReader.h"

#include <RobotAPI/libraries/aron/core/io/dataIO/converter/Converter.h>
#include <RobotAPI/libraries/aron/core/io/dataIO/reader/nlohmannJSON/NlohmannJSONReader.h>
#include <RobotAPI/libraries/aron/core/io/dataIO/writer/navigator/NavigatorWriter.h>
#include <RobotAPI/libraries/aron/core/io/typeIO/converter/Converter.h>
#include <RobotAPI/libraries/aron/core/io/typeIO/reader/nlohmannJSON/NlohmannJSONReader.h>
#include <RobotAPI/libraries/aron/core/io/typeIO/writer/navigator/NavigatorWriter.h>


namespace armarx::armem::io
{

    NlohmannJSONDiskReader::NlohmannJSONDiskReader(bool createFolder) :
        DiskReaderWriter(createFolder),
        DiskReader(createFolder)
    {
    }

    NlohmannJSONDiskReader::NlohmannJSONDiskReader(const std::string& rootPath, bool createFolder) :
        DiskReaderWriter(rootPath, createFolder),
        DiskReader(rootPath, createFolder)
    {
    }

    aron::datanavigator::DictNavigatorPtr NlohmannJSONDiskReader::getStringAsDataNavigator(const std::string& s, const aron::typenavigator::NavigatorPtr& expectedStructure) const
    {
        aron::dataIO::reader::NlohmannJSONReader dataReader(s);
        aron::dataIO::writer::NavigatorWriter navWriter;
        aron::dataIO::Converter::ConvertFromReader(dataReader, navWriter, expectedStructure);
        return aron::datanavigator::DictNavigator::DynamicCastAndCheck(navWriter.getResult());
    }

    aron::typenavigator::ObjectNavigatorPtr NlohmannJSONDiskReader::getStringAsTypeNavigator(const std::string& s) const
    {
        aron::typeIO::reader::NlohmannJSONReader typeReader(s);
        aron::typeIO::writer::NavigatorWriter navWriter;
        aron::typeIO::Converter::ConvertFromReader(typeReader, navWriter);
        return aron::typenavigator::ObjectNavigator::DynamicCastAndCheck(navWriter.getResult());
    }
}
