#include "NlohmannJSONDiskWriter.h"

#include <RobotAPI/libraries/aron/core/io/dataIO/visitor/Visitor.h>
#include <RobotAPI/libraries/aron/core/io/typeIO/visitor/Visitor.h>
#include <RobotAPI/libraries/aron/core/io/dataIO/writer/nlohmannJSON/NlohmannJSONWriter.h>
#include <RobotAPI/libraries/aron/core/io/typeIO/writer/nlohmannJSON/NlohmannJSONWriter.h>


namespace armarx::armem::io
{
    NlohmannJSONDiskWriter::NlohmannJSONDiskWriter(bool createFolder) :
        DiskReaderWriter(createFolder),
        DiskWriter(createFolder)
    {
    }

    NlohmannJSONDiskWriter::NlohmannJSONDiskWriter(const std::string& rootPath, bool createFolder) :
        DiskReaderWriter(rootPath, createFolder),
        DiskWriter(rootPath, createFolder)
    {
    }

    std::string NlohmannJSONDiskWriter::getDataAsString(const aron::datanavigator::DictNavigatorPtr& aronDataNav) const
    {
        aron::dataIO::writer::NlohmannJSONWriter dataWriter;
        aron::dataIO::Visitor::SetupWriterFromAronDataPtr(dataWriter, aronDataNav->getResult());
        return dataWriter.getResult().dump(2);
    }

    std::string NlohmannJSONDiskWriter::getTypeAsString(const aron::typenavigator::ObjectNavigatorPtr& aronTypeNav) const
    {
        aron::typeIO::writer::NlohmannJSONWriter typeWriter;
        aron::typeIO::Visitor::SetupWriterFromAronTypePtr(typeWriter, aronTypeNav->getResult());
        return typeWriter.getResult().dump(2);
    }
}
