#pragma once

#include <string>

#include <ArmarXCore/core/logging/Logging.h>
#include <ArmarXCore/core/application/properties/PropertyDefinitionContainer.h>

#include <ArmarXGui/libraries/RemoteGui/Client/Widgets.h>

#include <RobotAPI/libraries/ArmarXObjects/ObjectID.h>
#include <RobotAPI/libraries/ArmarXObjects/ObjectFinder.h>

#include <RobotAPI/libraries/armem/core/Memory.h>
#include <RobotAPI/libraries/armem/server/MemoryToIceAdapter.h>
#include <RobotAPI/libraries/armem_objects/aron/ObjectClass.aron.generated.h>


namespace armarx::armem::server::obj::clazz
{

    class Segment : public armarx::Logging
    {
    public:


    public:

        Segment(armem::server::MemoryToIceAdapter& iceMemory);


        void defineProperties(armarx::PropertyDefinitionsPtr defs, const std::string& prefix = "");
        void init();

        void loadByObjectFinder(const std::string& objectsPackage);
        void loadByObjectFinder(const ObjectFinder& finder);
        void loadByObjectFinder();


        armem::CoreSegment& getCoreSegment();
        const armem::CoreSegment& getCoreSegment() const;


        arondto::ObjectClass objectClassFromInfo(const ObjectInfo& info) const;


    private:

        armem::server::MemoryToIceAdapter& iceMemory;
        armem::CoreSegment* coreSegment = nullptr;

        ObjectFinder objectFinder;


        struct Properties
        {
            std::string coreSegmentName = "Class";
            long maxHistorySize = -1;

            std::string objectsPackage = ObjectFinder::DefaultObjectsPackageName;
            bool loadFromObjectsPackage = true;
        };
        Properties p;


    public:

        struct RemoteGui
        {
            armarx::RemoteGui::Client::GroupBox group;

            armarx::RemoteGui::Client::IntSpinBox maxHistorySize;
            armarx::RemoteGui::Client::CheckBox infiniteHistory;

            void setup(const Segment& data);
            void update(Segment& data);
        };

    };

}
