/*
 * This file is part of ArmarX.
 *
 * ArmarX is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.
 *
 * ArmarX is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 *
 * @package    RobotComponents::ArmarXObjects::
 * @author     Fabian Reister ( fabian dot reister at kit dot edu )
 * @date       2021
 * @copyright  http://www.gnu.org/licenses/gpl-2.0.txt
 *             GNU General Public License
 */


#pragma once

#include <RobotAPI/interface/units/LaserScannerUnit.h>


namespace armarx
{

    namespace aron
    {
        struct LaserScanStamped;
    } // namespace aron

    // struct LaserScan;
    struct LaserScanStamped;

    void fromAron(
        const aron::LaserScanStamped& aronLaserScan,
        LaserScan& laserScan,
        std::int64_t& timestamp,
        std::string& frame,
        std::string& agentName);

    void fromAron(const aron::LaserScanStamped& aronLaserScan, LaserScanStamped& laserScan);

    void toAron(
        const LaserScan& laserScan,
        const std::int64_t& timestamp,
        const std::string& frame,
        const std::string& agentName,
        aron::LaserScanStamped& aronLaserScan);

} // namespace armarx